Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.xpath
Class XPathFunctionLibrary

    java.lang.Object
      net.sf.saxon.xpath.XPathFunctionLibrary

All Implemented Interfaces:
  Serializable, FunctionLibrary

    public class XPathFunctionLibrary

extends Object
implements FunctionLibrary

The XPathFunctionLibrary is a FunctionLibrary that supports binding of XPath function calls to instances of the JAXP XPathFunction interface returned by an XPathFunctionResolver.

See Also:
  Serialized Form

Constructor Summary
`XPathFunctionLibrary()` Construct a XPathFunctionLibrary

Method Summary
`Expression` | `bind(int nameCode, String uri, String local, Expression[] staticArgs)` Bind a function, given the URI and local parts of the function name, and the list of expressions supplied as arguments.
`FunctionLibrary` | `copy()` This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.
`XPathFunctionResolver` | `getXPathFunctionResolver()` Get the resolver
`boolean` | `isAvailable(int fingerprint, String uri, String local, int arity)` Test whether an XPath function with a given name and arity is available.
`void` | `setXPathFunctionResolver(XPathFunctionResolver resolver)` Set the resolver

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### XPathFunctionLibrary

    public XPathFunctionLibrary()

  Construct a XPathFunctionLibrary

Method Detail

### setXPathFunctionResolver

    public void setXPathFunctionResolver(XPathFunctionResolver resolver)

  Set the resolver

  Parameters:
    `resolver` - The XPathFunctionResolver wrapped by this FunctionLibrary

### getXPathFunctionResolver

    public XPathFunctionResolver getXPathFunctionResolver()

  Get the resolver

  Returns:
    the XPathFunctionResolver wrapped by this FunctionLibrary

### isAvailable

    public boolean isAvailable(int fingerprint,
                               String uri,
                               String local,
                               int arity)

  Test whether an XPath function with a given name and arity is available. This supports the function-available() function in XSLT. It is thus never used, and always returns false

  Specified by:
    `isAvailable` in interface `FunctionLibrary`
  Parameters:
    `fingerprint` - The code that identifies the function name in the NamePool. This must match the supplied URI and local name.
    `uri` - The URI of the function name
    `local` - The local part of the function name
    `arity` - The number of arguments. This is set to -1 in the case of the single-argument function-available() function; in this case the method should return true if there is some matching extension function, regardless of its arity.

### bind

    public Expression bind(int nameCode,
                           String uri,
                           String local,
                           Expression[] staticArgs)
                    throws XPathException

  Bind a function, given the URI and local parts of the function name, and the list of expressions supplied as arguments. This method is called at compile time.

  Specified by:
    `bind` in interface `FunctionLibrary`
  Parameters:
    `nameCode` - The namepool code of the function name. This must match the supplied URI and local name.
    `uri` - The URI of the function name
    `local` - The local part of the function name
    `staticArgs` - The expressions supplied statically in the function call. The intention is that the static type of the arguments (obtainable via getItemType() and getCardinality() may be used as part of the binding algorithm.
  Returns:
    An object representing the extension function to be called, if one is found; null if no extension function was found matching the required name, arity, or signature.
  Throws:
    `XPathException` - if a function is found with the required name and arity, but the implementation of the function cannot be loaded or used; or if an error occurs while searching for the function.

### copy

    public FunctionLibrary copy()

  This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.

  Specified by:
    `copy` in interface `FunctionLibrary`
  Returns:
    a copy of this function library. This must be an instance of the original class.

Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (C) Michael H. Kay. All rights reserved.